Index: CMT/HEAD/ChangeLog
===================================================================
--- CMT/HEAD/ChangeLog	(revision 541)
+++ CMT/HEAD/ChangeLog	(revision 542)
@@ -1,2 +1,14 @@
+2010-04-05    <rybkin@lal.in2p3.fr> 429
+
+	* source/cmt_awk.cxx: For Windows, define PATH_MAX via _MAX_PATH
+	* source/cmt_system.cxx: idem. In function close_ostream, define prev_fail
+	and fclose_fail as int (rather than bool)
+	* source/cmt_pattern.cxx: In function ApplyPattern::action, print warning
+	pattern_not_found in DeveloperMode (i. e., in current package) and on the
+	condition requirements files are parsed recursively only (to avoid false
+	warnings)
+	* mgr/cmt_dependencies.nmake: Update
+	* mgr/VisualC.nmake: idem
+	
 2010-04-02    <rybkin@lal.in2p3.fr> 428
 
Index: CMT/HEAD/mgr/VisualC.nmake
===================================================================
--- CMT/HEAD/mgr/VisualC.nmake	(revision 541)
+++ CMT/HEAD/mgr/VisualC.nmake	(revision 542)
@@ -47,5 +47,4 @@
 mgr=..\mgr\ 
 application_suffix=.exe 
-lock_command=$(CMTROOT)\mgr\cmt_lockfile.bat  
 unlock_command=rmdir  
 lock_name=cmt 
Index: CMT/HEAD/mgr/cmt_dependencies.nmake
===================================================================
--- CMT/HEAD/mgr/cmt_dependencies.nmake	(revision 541)
+++ CMT/HEAD/mgr/cmt_dependencies.nmake	(revision 542)
@@ -4,5 +4,5 @@
 cmt_constituent_cxx_dependencies = "..\source\cmt_constituent.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_fragment.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_language.h" "..\source\cmt_awk.h" "..\source\cmt_map.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_pattern.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_deps_builder.h" "..\source\cmt_generator.h" "..\source\cmt_branch.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_project.h" "..\source\cmt_cmtpath_pattern.h" "..\source\cmt_database.h" "..\source\cmt_log.h"
 cmt_deps_builder_cxx_dependencies = "..\source\cmt_deps_builder.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_parser.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_map.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_pattern.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_deps_builder.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_log.h"
-cmt_fragment_cxx_dependencies = "..\source\cmt_fragment.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_fragment.h" "..\source\cmt_map.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_pattern.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_branch.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_language.h" "..\source\cmt_awk.h" "..\source\cmt_project.h" "..\source\cmt_cmtpath_pattern.h" "..\source\cmt_database.h" "..\source\cmt_log.h"
+cmt_fragment_cxx_dependencies = "..\source\cmt_fragment.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_fragment.h" "..\source\cmt_map.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_pattern.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_branch.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_language.h" "..\source\cmt_awk.h" "..\source\cmt_project.h" "..\source\cmt_cmtpath_pattern.h" "..\source\cmt_database.h" "..\source\cmt_log.h" "..\source\cmt_error.h"
 cmt_generator_cxx_dependencies = "..\source\cmt_generator.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_fragment.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_language.h" "..\source\cmt_awk.h" "..\source\cmt_map.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_pattern.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_deps_builder.h" "..\source\cmt_generator.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_generators.h" "..\source\cmt_log.h"
 cmt_include_cxx_dependencies = "..\source\cmt_include.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_include.h" "..\source\cmt_map.h" "..\source\cmt_script.h" "..\source\cmt_pattern.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_log.h"
@@ -16,6 +16,6 @@
 cmt_error_cxx_dependencies = "..\source\cmt_error.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_error.h" "..\source\cmt_vector.h" "..\source\cmt_log.h"
 cmt_pattern_cxx_dependencies = "..\source\cmt_pattern.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_parser.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_map.h" "..\source\cmt_pattern.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_branch.h" "..\source\cmt_fragment.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_language.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_awk.h" "..\source\cmt_project.h" "..\source\cmt_cmtpath_pattern.h" "..\source\cmt_database.h" "..\source\cmt_error.h" "..\source\cmt_syntax.h" "..\source\cmt_log.h"
-cmt_language_cxx_dependencies = "..\source\cmt_language.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_fragment.h" "..\source\cmt_language.h" "..\source\cmt_branch.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_map.h" "..\source\cmt_pattern.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_awk.h" "..\source\cmt_project.h" "..\source\cmt_cmtpath_pattern.h" "..\source\cmt_database.h"
-cmt_vcs_cxx_dependencies = "..\source\cmt_vcs.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_parser.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_cvs.h" "..\source\cmt_vcs.h" "..\source\cmt_awk.h" "..\source\cmt_map.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_pattern.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_project.h" "..\source\cmt_log.h" "..\source\cmt_error.h"
+cmt_language_cxx_dependencies = "..\source\cmt_language.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_fragment.h" "..\source\cmt_language.h" "..\source\cmt_branch.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_map.h" "..\source\cmt_pattern.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_awk.h" "..\source\cmt_project.h" "..\source\cmt_cmtpath_pattern.h" "..\source\cmt_database.h" "..\source\cmt_error.h"
+cmt_vcs_cxx_dependencies = "..\source\cmt_vcs.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_parser.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_cvs.h" "..\source\cmt_map.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_pattern.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_vcs.h" "..\source\cmt_awk.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_project.h" "..\source\cmt_log.h" "..\source\cmt_error.h" "..\source\cmt_syntax.h"
 cmt_group_cxx_dependencies = "..\source\cmt_group.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_group.h" "..\source\cmt_branch.h" "..\source\cmt_fragment.h" "..\source\cmt_constituent.h" "..\source\cmt_language.h" "..\source\cmt_map.h" "..\source\cmt_pattern.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_awk.h" "..\source\cmt_project.h" "..\source\cmt_cmtpath_pattern.h" "..\source\cmt_database.h"
 cmt_database_cxx_dependencies = "..\source\cmt_database.cxx" "..\source\cmt_vector.h" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_branch.h" "..\source\cmt_fragment.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_language.h" "..\source\cmt_map.h" "..\source\cmt_pattern.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_awk.h" "..\source\cmt_project.h" "..\source\cmt_cmtpath_pattern.h" "..\source\cmt_database.h"
@@ -29,5 +29,5 @@
 cmt_cmtpath_pattern_cxx_dependencies = "..\source\cmt_cmtpath_pattern.cxx" "..\source\cmt_vector.h" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_branch.h" "..\source\cmt_fragment.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_language.h" "..\source\cmt_map.h" "..\source\cmt_pattern.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_awk.h" "..\source\cmt_project.h" "..\source\cmt_cmtpath_pattern.h" "..\source\cmt_database.h" "..\source\cmt_syntax.h"
 cmt_sequence_cxx_dependencies = "..\source\cmt_sequence.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_regexp.h" "..\source\cmt_awk.h" "..\source\cmt_sequence.h" "..\source\cmt_vector.h" "..\source\cmt_system.h"
-cmt_generators_cxx_dependencies = "..\source\cmt_generators.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_fragment.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_language.h" "..\source\cmt_awk.h" "..\source\cmt_map.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_pattern.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_deps_builder.h" "..\source\cmt_generator.h" "..\source\cmt_generators.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_log.h"
+cmt_generators_cxx_dependencies = "..\source\cmt_generators.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_fragment.h" "..\source\cmt_group.h" "..\source\cmt_constituent.h" "..\source\cmt_language.h" "..\source\cmt_awk.h" "..\source\cmt_map.h" "..\source\cmt_include.h" "..\source\cmt_script.h" "..\source\cmt_pattern.h" "..\source\cmt_scope_section.h" "..\source\cmt_use.h" "..\source\cmt_deps_builder.h" "..\source\cmt_generator.h" "..\source\cmt_generators.h" "..\source\cmt_tag.h" "..\source\cmt_symbol.h" "..\source\cmt_log.h" "..\source\cmt_error.h"
 cmt_scope_section_cxx_dependencies = "..\source\cmt_scope_section.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_vector.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h" "..\source\cmt_parser.h" "..\source\cmt_scope_section.h"
 cmt_log_cxx_dependencies = "..\source\cmt_log.cxx" "..\source\cmt_std.h" "..\source\cmt_string.h" "..\source\cmt_log.h" "..\source\cmt_vector.h" "..\source\cmt_parser.h" "..\source\cmt_regexp.h" "..\source\cmt_system.h" "..\source\cmt.h"
Index: CMT/HEAD/source/cmt_awk.cxx
===================================================================
--- CMT/HEAD/source/cmt_awk.cxx	(revision 541)
+++ CMT/HEAD/source/cmt_awk.cxx	(revision 542)
@@ -9,4 +9,6 @@
 #define popen _popen
 #define pclose _pclose
+#include <stdlib.h>
+#define PATH_MAX _MAX_PATH
 #endif
 
Index: CMT/HEAD/source/cmt_pattern.cxx
===================================================================
--- CMT/HEAD/source/cmt_pattern.cxx	(revision 541)
+++ CMT/HEAD/source/cmt_pattern.cxx	(revision 542)
@@ -844,5 +844,6 @@
   if (p == 0) 
     {
-      if (Cmt::get_current_access () == DeveloperMode)
+      if (Cmt::get_current_access () == DeveloperMode &&
+	  Cmt::get_recursive ())
 	CmtMessage::warning (CmtError::get_error_name (CmtError::pattern_not_found) +
 			     ": " + name +
Index: CMT/HEAD/source/cmt_system.cxx
===================================================================
--- CMT/HEAD/source/cmt_system.cxx	(revision 541)
+++ CMT/HEAD/source/cmt_system.cxx	(revision 542)
@@ -29,4 +29,6 @@
 #define stat _stat
 #define WEXITSTATUS(w) (w)
+#include <stdlib.h>
+#define PATH_MAX _MAX_PATH
 
 #else
@@ -2448,6 +2450,8 @@
     }
 
-  bool prev_fail = ferror (stream);
-  bool fclose_fail = fclose (stream);
+  int prev_fail = ferror (stream);
+  int fclose_fail = fclose (stream);
+//   bool prev_fail = ferror (stream);
+//   bool fclose_fail = fclose (stream);
 
   if (prev_fail || fclose_fail)